<template>
    <v-row>
        <v-col>
            <h1>Detail rezervace</h1>
            <v-divider />
            <v-form>
                <v-row>
                    <v-col cols="8">
                        <v-select v-model="attributes.vyberProhlidka"
                                  label="Typ prohlídky"
                                  :items="prohlidky"
                                  item-text="nazev"
                                  return-object></v-select>
                    </v-col>
                    <v-col cols="8">
                        <v-select v-model="attributes.vyberPacient"
                                  label="Pacient"
                                  :items="pacienti"
                                  item-text="jmeno"
                                  return-object></v-select>
                    </v-col>
                    <v-col cols="8">
                        <v-text-field v-model="attributes.poznamka" label="Poznámka"></v-text-field>
                    </v-col>
                    <v-col cols="8">
                        Termín<p />
                        <v-date-picker v-model="attributes.termin" elevation="15" class="mt-4" :first-day-of-week="1" locale="cs-cz"></v-date-picker><p />
                    </v-col>
                </v-row>
                <v-row>
                    <v-col>
                        <v-btn right color="success" v-on:click="ulozitZmeny">
                            <v-icon>mdi-check</v-icon>
                        </v-btn>
                    </v-col>
                </v-row>
            </v-form>
        </v-col>
    </v-row>
</template>

<script>
    export default {
        data() {
            return {
                id: null,
                type: 'items',
                attributes: {
                    prohlidkaNazev: null,
                    pacientJmeno: null,
                    poznamka: null,
                    termin: null,
                    vyberProhlidka: null,
                    vyberPacient: null
                }
            }
        },
        async mounted() {
            const id = this.$route.params.id;
            const res = await this.$axios.get('/api/rezervace/' + id);
            const item = res.data;
            this.id = item.id;

            const resProhlidka = await this.$axios.get('/api/Prohlidka/' + item.idProhlidka);
            const prohlidka = resProhlidka.data;
            this.attributes.prohlidkaNazev = prohlidka.nazev;
            this.attributes.vyberProhlidka = prohlidka;

            const resProhlidky = await this.$axios.get('/api/Prohlidka');
            this.prohlidky = resProhlidky.data.sort(function (a, b) { return a.nazev > b.nazev });

            const resPacient = await this.$axios.get('/api/Pacient/' + item.idPacient);
            const pacient = resPacient.data;
            this.attributes.pacientJmeno = pacient.jmeno;
            this.attributes.vyberPacient = pacient;

            const resPacienti = await this.$axios.get('/api/Pacient');
            this.pacienti = resPacienti.data.sort(function (a, b) { return a.jmeno > b.jmeno });

            this.attributes.poznamka = item.poznamka;

            var t = item.termin.split(/[- :T]/)
            this.attributes.termin = `${t[0]}-${t[1]}-${t[2]}`;
        },
        methods: {
            ulozitZmeny: async function (event) {
                const res = await this.$axios.put('/api/Rezervace/' + this.id, {
                    id: this.id,
                    idPacient: this.attributes.vyberPacient.id,
                    idProhlidka: this.attributes.vyberProhlidka.id,
                    poznamka: this.attributes.poznamka,
                    termin: this.attributes.termin
                });
                console.log(res);
                location.href='/rezervace';
            }
        }
    }
</script>
